﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Opticon.Sysctl;

namespace SYSCTL_Sample
{
    public partial class Form1 : Form
    {
        Opticon.Sysctl.PowerControl PWC;

        public Form1()
        {
            InitializeComponent();

            PWC = new PowerControl();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Power Control Page Init
            if (PWC.PowerDownDisableMode)
                checkBox_PowerDownDisableMode.Checked = true;
            else
                checkBox_PowerDownDisableMode.Checked = false;
            
            int index = 0;
            
            switch (PWC.BatteryBacklightTimeout)
            {
                case BacklightTimeout_Battery.TEN_SEC:
                    index = 0; break;
                case BacklightTimeout_Battery.THIRTY_SEC:
                    index = 1; break;
                case BacklightTimeout_Battery.ONE_MIN:
                    index = 2; break;
                case BacklightTimeout_Battery.TWO_MIN:
                    index = 3; break;
                case BacklightTimeout_Battery.THREE_MIN:
                    index = 4; break;
                case BacklightTimeout_Battery.FOUR_MIN:
                    index = 5; break;
                case BacklightTimeout_Battery.FIVE_MIN:
                    index = 6; break;
                case BacklightTimeout_Battery.INDEFINITELY:
                    index = 7; break;
            }
            comboBox_Battery_BacklightTimeout.SelectedIndex = index;

            switch (PWC.ACBacklightTimeout)
            {
                case BacklightTimeout_AC.ONE_MIN:
                    index = 0; break;
                case BacklightTimeout_AC.TWO_MIN:
                    index = 1; break;
                case BacklightTimeout_AC.THREE_MIN:
                    index = 2; break;
                case BacklightTimeout_AC.FOUR_MIN:
                    index = 3; break;
                case BacklightTimeout_AC.FIVE_MIN:
                    index = 4; break;
                case BacklightTimeout_AC.SIX_MIN:
                    index = 5; break;
                case BacklightTimeout_AC.SEVEN_MIN:
                    index = 6; break;
                case BacklightTimeout_AC.EIGHT_MIN:
                    index = 7; break;
                case BacklightTimeout_AC.NINE_MIN:
                    index = 8; break;
                case BacklightTimeout_AC.TEN_MIN:
                    index = 9; break;
                case BacklightTimeout_AC.INDEFINITELY:
                    index = 10; break;
            }
            comboBox_AC_BacklightTimeout.SelectedIndex = index;
        }

        private void checkBox_PowerDownDisableMode_CheckStateChanged(object sender, EventArgs e)
        {
            if (checkBox_PowerDownDisableMode.Checked)
                PWC.PowerDownDisableMode = true;
            else
                PWC.PowerDownDisableMode = false;
        }

        private void button_PowerDownResume_Click(object sender, EventArgs e)
        {
            PWC.PowerDown(OnMode.Resume);
        }

        private void button_PowerDownReset_Click(object sender, EventArgs e)
        {
            PWC.PowerDown(OnMode.Reset);
        }

        private void comboBox_Battery_BacklightTimeout_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBox_Battery_BacklightTimeout.SelectedIndex)
            {
                case 0:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.TEN_SEC; break;
                case 1:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.THIRTY_SEC; break;
                case 2:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.ONE_MIN; break;
                case 3:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.TWO_MIN; break;
                case 4:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.THREE_MIN; break;
                case 5:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.FOUR_MIN; break;
                case 6:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.FIVE_MIN; break;
                case 7:
                    PWC.BatteryBacklightTimeout = BacklightTimeout_Battery.INDEFINITELY; break;
            }
        }

        private void comboBox_AC_BacklightTimeout_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBox_AC_BacklightTimeout.SelectedIndex)
            {
                case 0:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.ONE_MIN; break;
                case 1:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.TWO_MIN; break;
                case 2:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.THREE_MIN; break;
                case 3:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.FOUR_MIN; break;
                case 4:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.FIVE_MIN; break;
                case 5:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.SIX_MIN; break;
                case 6:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.SEVEN_MIN; break;
                case 7:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.EIGHT_MIN; break;
                case 8:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.NINE_MIN; break;
                case 9:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.TEN_MIN; break;
                case 10:
                    PWC.ACBacklightTimeout = BacklightTimeout_AC.INDEFINITELY; break;
            }
        }
    }
}