Public Class Form1
    Private BCR As New Opticon.Bcrctl.BarcodeReader
    Private BCD As New Opticon.Bcrctl.BarcodeDecoder
    Private KBD As New Opticon.Sysctl.Keyboard

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Initialize
        BCR.PowerOn = True
        BCR.TriggerKeyEnabled = False
        BCR.OutputMode = Opticon.Bcrctl.DataOutput.BUFFER
        BCD.SuffixChar = 0
        KBD.FunctionKeyEnable = False

        WindowState = FormWindowState.Maximized
        textBox_BarcodeData.Focus()

        AddHandler BCD.DataHandler, AddressOf decoder_DataHandler
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        ' Recovery
        BCR.TriggerKeyEnabled = True
        BCR.OutputMode = Opticon.Bcrctl.DataOutput.CLIPBOARD
        BCD.SuffixChar = 13
        KBD.FunctionKeyEnable = True

        RemoveHandler BCD.DataHandler, AddressOf decoder_DataHandler
    End Sub

    Private Sub decoder_DataHandler(ByVal sender As Object, ByVal e As Opticon.Bcrctl.ScanEventArgs)
        If e.ReadStatus = Opticon.Bcrctl.LastReadStatusList.GOOD Then
            ' Show result
            textBox_BarcodeData.Text = System.Text.Encoding.Default.GetString(e.BarcodeData, 0, CInt(e.DataLength))
        Else
            ' Show error-message
            textBox_BarcodeData.Text = e.ReadStatus.ToString()
        End If
    End Sub

    Private Sub textBox_BarcodeData_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles textBox_BarcodeData.KeyDown
        Select Case Convert.ToUInt16(e.KeyCode)
            Case &HE3   ' Q1 key
                BCR.TriggerPress()
                System.Threading.Thread.Sleep(100)
                BCR.TriggerRelease()
            Case &HE4   ' Q2 key
                BCD.AbortScan()
                textBox_BarcodeData.Text = ""
        End Select
    End Sub
End Class
